﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace Shadebitmap
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.openFileDialog1.InitialDirectory = Application.StartupPath;
            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox1.ImageLocation = this.openFileDialog1.FileName;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (this.pictureBox1.Image == null)
            {
                MessageBox.Show("Fill a bitmap image.", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            Bitmap bitmap = (Bitmap) this.pictureBox1.Image;
            int w = this.progressBar1.Maximum = bitmap.Width;
            int h = bitmap.Height;
            byte c;
            Color pixelColor;

            this.progressBar1.Value = this.progressBar1.Minimum = 0;
            for (int x = 0; x < w; x++)
            {
                for (int y = 0; y < h; y++)
                {
                    pixelColor = bitmap.GetPixel(x, y);
                    c = (byte) Math.Round((double)(pixelColor.R + pixelColor.G + pixelColor.B) / 3.0, 0);
                    pixelColor = Color.FromArgb(c, c, c);
                    bitmap.SetPixel(x, y, pixelColor);
                }
                this.progressBar1.Value++;
            }
            this.progressBar1.Value = 0;
            this.pictureBox1.Refresh();
        }
    }
}
